diff -urN punbb-1.3.4/admin/bans.php punbb-1.3.6/admin/bans.php
--- punbb-1.3.4/admin/bans.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/admin/bans.php	2011-09-19 06:35:43.557425000 +0000
@@ -24,7 +24,6 @@
 require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
 require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_bans.php';
 
-
 // Add/edit a ban (stage 1)
 if (isset($_REQUEST['add_ban']) || isset($_GET['edit_ban']))
 {
@@ -384,7 +383,7 @@
 
 // Setup the form
 $forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;
-$forum_page['form_action'] = forum_link($forum_url['admin_bans']).'?action=more';
+$forum_page['form_action'] = forum_link($forum_url['admin_bans']).'&amp;action=more';
 
 $forum_page['hidden_fields'] = array(
 	'csrf_token'	=> '<input type="hidden" name="csrf_token" value="'.generate_form_token($forum_page['form_action']).'" />'
@@ -400,6 +399,34 @@
 $forum_page['crumbs'][] = array($lang_admin_common['Bans'], forum_link($forum_url['admin_bans']));
 
 
+// Fetch user count
+$query = array(
+	'SELECT'	=>	'COUNT(id)',
+	'FROM'		=>	'bans'
+);
+
+$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+$forum_page['num_bans'] = $forum_db->result($result);
+$forum_page['num_pages'] = ceil($forum_page['num_bans'] / $forum_user['disp_topics']);
+$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : intval($_GET['p']);
+$forum_page['start_from'] = $forum_user['disp_topics'] * ($forum_page['page'] - 1);
+$forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_topics']), ($forum_page['num_bans']));
+
+// Generate paging
+$forum_page['page_post']['paging']='<p class="paging"><span class="pages">'.$lang_common['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $forum_url['admin_bans'], $lang_common['Paging separator'], null, true).'</p>';
+
+// Navigation links for header and page numbering for title/meta description
+if ($forum_page['page'] < $forum_page['num_pages'])
+{
+	$forum_page['nav']['last'] = '<link rel="last" href="'.forum_sublink($forum_url['admin_bans'], $forum_url['page'], $forum_page['num_pages']).'" title="'.$lang_common['Page'].' '.$forum_page['num_pages'].'" />';
+	$forum_page['nav']['next'] = '<link rel="next" href="'.forum_sublink($forum_url['admin_bans'], $forum_url['page'], ($forum_page['page'] + 1)).'" title="'.$lang_common['Page'].' '.($forum_page['page'] + 1).'" />';
+}
+if ($forum_page['page'] > 1)
+{
+	$forum_page['nav']['prev'] = '<link rel="prev" href="'.forum_sublink($forum_url['admin_bans'], $forum_url['page'], ($forum_page['page'] - 1)).'" title="'.$lang_common['Page'].' '.($forum_page['page'] - 1).'" />';
+	$forum_page['nav']['first'] = '<link rel="first" href="'.forum_link($forum_url['admin_bans']).'" title="'.$lang_common['Page'].' 1" />';
+}
+
 ($hook = get_hook('aba_pre_header_load')) ? eval($hook) : null;
 
 define('FORUM_PAGE_SECTION', 'users');
@@ -449,15 +476,31 @@
 	<div class="main-content main-frm">
 <?php
 
-if (!empty($forum_bans))
+if ($forum_page['num_bans'] > 0)
 {
 
 ?>
 		<div class="ct-group">
 <?php
 
+	// Grab the bans
+	$query = array(
+		'SELECT'	=> 'b.*, u.username AS ban_creator_username',
+		'FROM'		=> 'bans AS b',
+		'JOINS'		=> array(
+			array(
+				'LEFT JOIN'		=> 'users AS u',
+				'ON'			=> 'u.id=b.ban_creator'
+			)
+		),
+		'ORDER BY'	=> 'b.id',
+		'LIMIT'		=> $forum_page['start_from'].', '.$forum_page['finish_at']
+	);
+
+	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+
 	$forum_page['item_num'] = 0;
-	foreach ($forum_bans as $ban_key => $cur_ban)
+	while ($cur_ban = $forum_db->fetch_assoc($result))
 	{
 		$forum_page['ban_info'] = array();
 		$forum_page['ban_creator'] = ($cur_ban['ban_creator_username'] != '') ? '<a href="'.forum_link($forum_url['user'], $cur_ban['ban_creator']).'">'.forum_htmlencode($cur_ban['ban_creator_username']).'</a>' : $lang_admin_common['Unknown'];
@@ -484,7 +527,7 @@
 				<div class="ct-box">
 					<div class="ct-legend">
 						<h3 class=""><span><?php printf($lang_admin_bans['Current ban head'], $forum_page['ban_creator']) ?></span></h3>
-						<p><?php printf($lang_admin_bans['Edit or remove'], '<a href="'.forum_link($forum_url['admin_bans']).'?edit_ban='.$cur_ban['id'].'">'.$lang_admin_bans['Edit ban'].'</a>', '<a href="'.forum_link($forum_url['admin_bans']).'?del_ban='.$cur_ban['id'].'&amp;csrf_token='.generate_form_token('del_ban'.$cur_ban['id']).'">'.$lang_admin_bans['Remove ban'].'</a>') ?></p>
+						<p><?php printf($lang_admin_bans['Edit or remove'], '<a href="'.forum_link($forum_url['admin_bans']).'&amp;edit_ban='.$cur_ban['id'].'">'.$lang_admin_bans['Edit ban'].'</a>', '<a href="'.forum_link($forum_url['admin_bans']).'&amp;del_ban='.$cur_ban['id'].'&amp;csrf_token='.generate_form_token('del_ban'.$cur_ban['id']).'">'.$lang_admin_bans['Remove ban'].'</a>') ?></p>
 					</div>
 <?php if (!empty($forum_page['ban_info'])): ?>
 				<ul>
diff -urN punbb-1.3.4/admin/db_update.php punbb-1.3.6/admin/db_update.php
--- punbb-1.3.4/admin/db_update.php	2009-05-20 09:20:51.420801000 +0000
+++ punbb-1.3.6/admin/db_update.php	2011-09-19 06:35:43.557425000 +0000
@@ -4,13 +4,13 @@
  *
  * Updates the database to the latest version.
  *
- * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
-define('UPDATE_TO', '1.3.4');
+define('UPDATE_TO', '1.3.6');
 define('UPDATE_TO_DB_REVISION', 4);
 
 // The number of items to process per pageview (lower this if the update script times out during UTF-8 conversion)
@@ -39,14 +39,15 @@
 	exit('Cannot find config.php, are you sure it exists?');
 
 // Enable debug mode
-if (!defined('FORUM_DEBUG')) 
+if (!defined('FORUM_DEBUG'))
 	define('FORUM_DEBUG', 1);
 
 // Turn on full PHP error reporting
 error_reporting(E_ALL);
 
 // Turn off magic_quotes_runtime
-set_magic_quotes_runtime(0);
+if (get_magic_quotes_runtime())
+	@ini_set('magic_quotes_runtime', false);
 
 // Turn off PHP time limit
 @set_time_limit(0);
@@ -1169,6 +1170,10 @@
 			}
 		}
 
+		// Add the index for the post time
+		if (!$forum_db->index_exists('posts', 'posted_idx'))
+			$forum_db->add_index('posts', 'posted_idx', array('posted'));
+
 		// Move any users with the old unverified status to their new group
 		$query = array(
 			'UPDATE'	=> 'users',
@@ -1207,7 +1212,9 @@
 		}
 
 		// Should we do charset conversion or not?
-		if (strpos($cur_version, '1.2') === 0 && isset($_GET['convert_charset']))
+		if (strpos($cur_version, '1.3') === 0)
+			$query_str = '?stage=finish';
+		elseif (strpos($cur_version, '1.2') === 0 && isset($_GET['convert_charset']))
 			$query_str = '?stage=conv_misc&req_old_charset='.$old_charset.'&req_per_page='.PER_PAGE;
 		else
 			$query_str = '?stage=conv_tables';
diff -urN punbb-1.3.4/admin/index.php punbb-1.3.6/admin/index.php
--- punbb-1.3.4/admin/index.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/admin/index.php	2010-03-01 12:08:07.894564000 +0000
@@ -140,7 +140,7 @@
 else if (ini_get('eaccelerator.enable'))
 	$php_accelerator = '<a href="http://eaccelerator.net/">eAccelerator</a>';
 else if (ini_get('xcache.cacher'))
-	$php_accelerator = '<a href="http://trac.lighttpd.net/xcache/">XCache</a>';
+	$php_accelerator = '<a href="http://xcache.lighttpd.net/">XCache</a>';
 else
 	$php_accelerator = $lang_admin_index['Not applicable'];
 
diff -urN punbb-1.3.4/admin/install.php punbb-1.3.6/admin/install.php
--- punbb-1.3.4/admin/install.php	2009-05-20 09:20:51.420801000 +0000
+++ punbb-1.3.6/admin/install.php	2011-09-19 06:35:43.557425000 +0000
@@ -4,13 +4,13 @@
  *
  * Used to actually install PunBB.
  *
- * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
-define('FORUM_VERSION', '1.3.4');
+define('FORUM_VERSION', '1.3.6');
 define('FORUM_DB_REVISION', 4);
 define('MIN_PHP_VERSION', '4.3.0');
 define('MIN_MYSQL_VERSION', '4.1.2');
@@ -62,9 +62,9 @@
 if (!file_exists(FORUM_ROOT.'lang/'.$language.'/install.php'))
 	exit('The language pack you have chosen doesn\'t seem to exist or is corrupt. Please recheck and try again.');
 
-// Load the language file
+// Load the language files
 require FORUM_ROOT.'lang/'.$language.'/install.php';
-
+require FORUM_ROOT.'lang/'.$language.'/admin_settings.php';
 
 if (isset($_POST['generate_config']))
 {
@@ -92,7 +92,10 @@
 	$dual_mysql = false;
 	$db_extensions = array();
 	if (function_exists('mysqli_connect'))
+	{
 		$db_extensions[] = array('mysqli', 'MySQL Improved');
+	}
+
 	if (function_exists('mysql_connect'))
 	{
 		$db_extensions[] = array('mysql', 'MySQL Standard');
@@ -216,7 +219,7 @@
 			<div class="sf-set set1">
 				<div class="sf-box text required">
 					<label for="fld2"><span><?php echo $lang_install['Database server'] ?> <em><?php echo $lang_install['Required'] ?></em></span> <small><?php echo $lang_install['Database server help'] ?></small></label><br />
-					<span class="fld-input"><input id="fld2" type="text" name="req_db_host" value="localhost" size="50" maxlength="100" /></span>
+					<span class="fld-input"><input id="fld2" type="text" name="req_db_host" value="localhost" size="35" maxlength="100" /></span>
 				</div>
 			</div>
 			<div class="sf-set set2">
@@ -276,7 +279,7 @@
 			<div class="sf-set set4">
 				<div class="sf-box text required">
 					<label for="fld10"><span><?php echo $lang_install['Admin e-mail'] ?> <em><?php echo $lang_install['Required'] ?></em></span> <small><?php echo $lang_install['E-mail address help'] ?></small></label><br />
-					<span class="fld-input"><input id="fld10" type="text" name="req_email" size="50" maxlength="80" /></span>
+					<span class="fld-input"><input id="fld10" type="text" name="req_email" size="35" maxlength="80" /></span>
 				</div>
 			</div>
 		</fieldset>
@@ -297,19 +300,19 @@
 			<div class="sf-set set1">
 				<div class="sf-box text">
 					<label for="fld11"><span><?php echo $lang_install['Board title'] ?></span></label><br />
-					<span class="fld-input"><input id="fld11" type="text" name="board_title" size="50" maxlength="255" /></span>
+					<span class="fld-input"><input id="fld11" type="text" name="board_title" size="35" maxlength="255" /></span>
 				</div>
 			</div>
 			<div class="sf-set set2">
 				<div class="sf-box text">
 					<label for="fld12"><span><?php echo $lang_install['Board description'] ?></span></label><br />
-					<span class="fld-input"><input id="fld12" type="text" name="board_descrip" size="50" maxlength="255" /></span>
+					<span class="fld-input"><input id="fld12" type="text" name="board_descrip" size="35" maxlength="255" /></span>
 				</div>
 			</div>
 			<div class="sf-set set3">
 				<div class="sf-box text required">
 					<label for="fld13"><span><?php echo $lang_install['Base URL'] ?> <em><?php echo $lang_install['Required'] ?></em></span> <small><?php echo $lang_install['Base URL help'] ?></small></label><br />
-					<span class="fld-input"><input id="fld13" type="text" name="req_base_url" value="<?php echo $base_url_guess ?>" size="60" maxlength="100" /></span>
+					<span class="fld-input"><input id="fld13" type="text" name="req_base_url" value="<?php echo $base_url_guess ?>" size="35" maxlength="100" /></span>
 				</div>
 			</div>
 <?php
@@ -473,7 +476,7 @@
 	{
 		$mysql_info = $forum_db->get_version();
 		if (version_compare($mysql_info['version'], MIN_MYSQL_VERSION, '<'))
-			error(sprintf($lang_install['Invalid MySQL version'], $mysql_version, MIN_MYSQL_VERSION));
+			error(sprintf($lang_install['Invalid MySQL version'], forum_htmlencode($mysql_info['version']), MIN_MYSQL_VERSION));
 	}
 
 	// Validate prefix
@@ -1020,7 +1023,8 @@
 		'PRIMARY KEY'	=> array('id'),
 		'INDEXES'		=> array(
 			'topic_id_idx'	=> array('topic_id'),
-			'multi_idx'		=> array('poster_id', 'topic_id')
+			'multi_idx'		=> array('poster_id', 'topic_id'),
+			'posted_idx'	=> array('posted')
 		)
 	);
 
@@ -1602,7 +1606,7 @@
 		'o_date_format'				=> "'Y-m-d'",
 		'o_check_for_updates'		=> "'$check_for_updates'",
 		'o_check_for_versions'		=> "'$check_for_updates'",
-		'o_timeout_visit'			=> "'1800'",
+		'o_timeout_visit'			=> "'5400'",
 		'o_timeout_online'			=> "'300'",
 		'o_redirect_delay'			=> "'1'",
 		'o_show_version'			=> "'0'",
@@ -1655,7 +1659,7 @@
 		'o_rules'					=> "'0'",
 		'o_rules_message'			=> "'".$lang_install['Default rules']."'",
 		'o_maintenance'				=> "'0'",
-		'o_maintenance_message'		=> "'".$lang_install['Default maint message']."'",
+		'o_maintenance_message'		=> "'".$lang_admin_settings['Maintenance message default']."'",
 		'o_default_dst'				=> "'0'",
 		'p_message_bbcode'			=> "'1'",
 		'p_message_img_tag'			=> "'1'",
@@ -1746,12 +1750,13 @@
 
 
 	$alerts = array();
+
 	// Check if the cache directory is writable
-	if (!is_writable('./cache/'))
+	if (!is_writable(FORUM_ROOT.'cache/'))
 		$alerts[] = '<li><span>'.$lang_install['No cache write'].'</span></li>';
 
 	// Check if default avatar directory is writable
-	if (!is_writable('./img/avatars/'))
+	if (!is_writable(FORUM_ROOT.'img/avatars/'))
 		$alerts[] = '<li><span>'.$lang_install['No avatar write'].'</span></li>';
 
 	// Check if we disabled uploading avatars because file_uploads was disabled
@@ -1843,9 +1848,6 @@
 	<p><?php echo $lang_install['Success welcome'] ?></p>
 </div>
 
-<?php
-?>
-
 <div id="brd-main" class="main basic">
 
 	<div class="main-head">
@@ -1853,7 +1855,14 @@
 	</div>
 
 	<div class="main-content main-frm">
-<?php
+<?php if (!empty($alerts)): ?>
+		<div class="ct-box error-box">
+			<p class="warn"><strong><?php echo $lang_install['Warning'] ?></strong></p>
+			<ul>
+				<?php echo implode("\n\t\t\t\t", $alerts)."\n" ?>
+			</ul>
+		</div>
+<?php endif;
 
 if (!$written)
 {
@@ -1863,14 +1872,6 @@
 			<p class="warn"><?php echo $lang_install['No write info 1'] ?></p>
 			<p class="warn"><?php printf($lang_install['No write info 2'], '<a href="'.FORUM_ROOT.'index.php">'.$lang_install['Go to index'].'</a>') ?></p>
 		</div>
-<?php if (!empty($alerts)): ?>
-		<div class="ct-box error-box">
-			<p class="warn"><strong><?php echo $lang_install['Warning'] ?></strong></p>
-			<ul>
-				<?php echo implode("\n\t\t\t\t", $alerts)."\n" ?>
-			</ul>
-		</div>
-<?php endif; ?>
 		<form class="frm-form" method="post" accept-charset="utf-8" action="install.php">
 			<div class="hidden">
 			<input type="hidden" name="generate_config" value="1" />
diff -urN punbb-1.3.4/admin/users.php punbb-1.3.6/admin/users.php
--- punbb-1.3.4/admin/users.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/admin/users.php	2011-03-18 12:01:21.480417000 +0000
@@ -812,83 +812,116 @@
 }
 
 
-else if (isset($_POST['find_user']))
+else if (isset($_GET['find_user']))
 {
-	$form = $_POST['form'];
-	$form['username'] = $_POST['username'];
+	$form = isset($_GET['form']) ? $_GET['form'] : array();
+
+	// trim() all elements in $form
+	$form = array_map('forum_trim', $form);
+	$conditions = $query_str = array();
 
 	//Check up for order_by and direction values
-	$order_by = isset($_POST['order_by']) ? forum_trim($_POST['order_by']) : null;
-	$direction = isset($_POST['direction']) ? forum_trim($_POST['direction']) : null;
+	$order_by = isset($_GET['order_by']) ? forum_trim($_GET['order_by']) : null;
+	$direction = isset($_GET['direction']) ? forum_trim($_GET['direction']) : null;
 	if ($order_by == null || $direction == null)
 		message($lang_common['Bad request']);
+
 	if (!in_array($order_by, array('username', 'email', 'num_posts', 'num_posts', 'registered')) || !in_array($direction, array('ASC', 'DESC')))
 		message($lang_common['Bad request']);
 
 	($hook = get_hook('aus_find_user_selected')) ? eval($hook) : null;
 
-	// forum_trim() all elements in $form
-	$form = array_map('trim', $form);
-	$conditions = array();
-
-	$posts_greater = forum_trim($_POST['posts_greater']);
-	$posts_less = forum_trim($_POST['posts_less']);
-	$last_post_after = forum_trim($_POST['last_post_after']);
-	$last_post_before = forum_trim($_POST['last_post_before']);
-	$registered_after = forum_trim($_POST['registered_after']);
-	$registered_before = forum_trim($_POST['registered_before']);
-	$user_group = $_POST['user_group'];
+	$query_str[] = 'order_by='.$order_by;
+	$query_str[] = 'direction='.$direction;
+
+	$posts_greater = isset($_GET['posts_greater']) ? forum_trim($_GET['posts_greater']) : '';
+	$posts_less = isset($_GET['posts_less']) ? forum_trim($_GET['posts_less']) : '';
+	$last_post_after = isset($_GET['last_post_after']) ? forum_trim($_GET['last_post_after']) : '';
+	$last_post_before = isset($_GET['last_post_before']) ? forum_trim($_GET['last_post_before']) : '';
+	$registered_after = isset($_GET['registered_after']) ? forum_trim($_GET['registered_after']) : '';
+	$registered_before = isset($_GET['registered_before']) ? forum_trim($_GET['registered_before']) : '';
+	$user_group = isset($_GET['user_group']) ? intval($_GET['user_group']) : -1;
+
+	$query_str[] = 'user_group='.$user_group;
 
 	if ((!empty($posts_greater) || !empty($posts_less)) && !ctype_digit($posts_greater.$posts_less))
 		message($lang_admin_users['Non numeric value message']);
 
 	// Try to convert date/time to timestamps
 	if ($last_post_after != '')
-		$last_post_after = strtotime($last_post_after);
-	if ($last_post_before != '')
-		$last_post_before = strtotime($last_post_before);
-	if ($registered_after != '')
-		$registered_after = strtotime($registered_after);
-	if ($registered_before != '')
-		$registered_before = strtotime($registered_before);
+	{
+		$query_str[] = 'last_post_after='.$last_post_after;
 
-	if ($last_post_after == -1 || $last_post_before == -1 || $registered_after == -1 || $registered_before == -1)
-		message($lang_admin_users['Invalid date/time message']);
+		$last_post_after = strtotime($last_post_after);
+		if ($last_post_after === false || $last_post_after == -1)
+			message($lang_admin_users['Invalid date/time message']);
 
-	if ($last_post_after != '')
 		$conditions[] = 'u.last_post>'.$last_post_after;
+	}
 	if ($last_post_before != '')
+	{
+		$query_str[] = 'last_post_before='.$last_post_before;
+
+		$last_post_before = strtotime($last_post_before);
+		if ($last_post_before === false || $last_post_before == -1)
+			message($lang_admin_users['Invalid date/time message']);
+
 		$conditions[] = 'u.last_post<'.$last_post_before;
+	}
 	if ($registered_after != '')
+	{
+		$query_str[] = 'registered_after='.$registered_after;
+
+		$registered_after = strtotime($registered_after);
+		if ($registered_after === false || $registered_after == -1)
+			message($lang_admin_users['Invalid date/time message']);
+
 		$conditions[] = 'u.registered>'.$registered_after;
+	}
 	if ($registered_before != '')
+	{
+		$query_str[] = 'registered_before='.$registered_before;
+
+		$registered_before = strtotime($registered_before);
+		if ($registered_before === false || $registered_before == -1)
+			message($lang_admin_users['Invalid date/time message']);
+
 		$conditions[] = 'u.registered<'.$registered_before;
+	}
 
 	$like_command = ($db_type == 'pgsql') ? 'ILIKE' : 'LIKE';
 	foreach ($form as $key => $input)
 	{
 		if ($input != '' && in_array($key, array('username', 'email', 'title', 'realname', 'url', 'jabber', 'icq', 'msn', 'aim', 'yahoo', 'location', 'signature', 'admin_note')))
+		{
 			$conditions[] = 'u.'.$forum_db->escape($key).' '.$like_command.' \''.$forum_db->escape(str_replace('*', '%', $input)).'\'';
+			$query_str[] = 'form%5B'.$key.'%5D='.urlencode($input);
+		}
 	}
 
 	if ($posts_greater != '')
+	{
+		$query_str[] = 'posts_greater='.$posts_greater;
 		$conditions[] = 'u.num_posts>'.$posts_greater;
+	}
 	if ($posts_less != '')
+	{
+		$query_str[] = 'posts_less='.$posts_less;
 		$conditions[] = 'u.num_posts<'.$posts_less;
+	}
 
-	if ($user_group != 'all')
+	if ($user_group > -1)
 		$conditions[] = 'u.group_id='.intval($user_group);
 
 	if (empty($conditions))
 		message($lang_admin_users['No search terms message']);
 
-
 	// Load the misc.php language file
 	require FORUM_ROOT.'lang/'.$forum_user['language'].'/misc.php';
 
-	// Find any users matching the conditions
+	// Fetch user count
 	$query = array(
-		'SELECT'	=> 'u.id, u.username, u.email, u.title, u.num_posts, u.admin_note, g.g_id, g.g_user_title',
+		'SELECT'	=> 'COUNT(id)',
 		'FROM'		=> 'users AS u',
 		'JOINS'		=> array(
 			array(
@@ -896,14 +929,17 @@
 				'ON'			=> 'g.g_id=u.group_id'
 			)
 		),
-		'WHERE'		=> 'u.id>1 AND '.implode(' AND ', $conditions),
-		'ORDER BY'	=> $order_by.' '.$direction
+		'WHERE'		=> 'u.id>1 AND '.implode(' AND ', $conditions)
 	);
 
-	($hook = get_hook('aus_find_user_qr_find_users')) ? eval($hook) : null;
-	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
-	$forum_page['num_users'] = $forum_db->num_rows($result);
+	($hook = get_hook('aus_find_user_qr_count_find_users')) ? eval($hook) : null;
 
+	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+	$forum_page['num_users'] = $forum_db->result($result);
+	$forum_page['num_pages'] = ceil($forum_page['num_users'] / $forum_user['disp_topics']);
+	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
+	$forum_page['start_from'] = $forum_user['disp_topics'] * ($forum_page['page'] - 1);
+	$forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_topics']), ($forum_page['num_users']));
 
 	// Setup breadcrumbs
 	$forum_page['crumbs'] = array(
@@ -915,6 +951,9 @@
 	$forum_page['crumbs'][] = array($lang_admin_common['Searches'], forum_link($forum_url['admin_users']));
 	$forum_page['crumbs'][] = $lang_admin_users['User search results'];
 
+	// Generate paging
+	$forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_common['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $forum_url['admin_users'].'?find_user=&amp;'.implode('&amp;', $query_str), $lang_common['Paging separator'], null, true).'</p>';
+
 	($hook = get_hook('aus_find_user_pre_header_load')) ? eval($hook) : null;
 
 	define('FORUM_PAGE_SECTION', 'users');
@@ -961,6 +1000,25 @@
 			<tbody>
 <?php
 
+	// Find any users matching the conditions
+	$query = array(
+		'SELECT'	=> 'u.id, u.username, u.email, u.title, u.num_posts, u.admin_note, g.g_id, g.g_user_title',
+		'FROM'		=> 'users AS u',
+		'JOINS'		=> array(
+			array(
+				'LEFT JOIN'		=> 'groups AS g',
+				'ON'			=> 'g.g_id=u.group_id'
+			)
+		),
+		'WHERE'		=> 'u.id>1 AND '.implode(' AND ', $conditions),
+		'ORDER BY'	=> $order_by.' '.$direction,
+		'LIMIT'		=> $forum_page['start_from'].', '.$forum_page['finish_at']
+	);
+
+	($hook = get_hook('aus_find_user_qr_find_users')) ? eval($hook) : null;
+
+	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+
 	if ($forum_page['num_users'] > 0)
 	{
 		$forum_page['item_count'] = 0;
@@ -1107,7 +1165,7 @@
 		<h2 class="hn"><span><?php echo $lang_admin_users['Search head'] ?></span></h2>
 	</div>
 	<div class="main-content main-frm">
-		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['admin_users']) ?>?action=find_user">
+		<form class="frm-form" method="get" accept-charset="utf-8" action="<?php echo forum_link($forum_url['admin_users']) ?>">
 			<div class="hidden">
 				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['admin_users']).'?action=find_user') ?>" />
 			</div>
@@ -1121,28 +1179,28 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['Username label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="username" size="25" maxlength="25" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[username]" size="35" maxlength="25" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_user_title')) ? eval($hook) : null; ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['Title label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[title]" size="30" maxlength="50" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[title]" size="35" maxlength="50" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_realname')) ? eval($hook) : null; ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['Real name label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[realname]" size="30" maxlength="40" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[realname]" size="35" maxlength="40" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_location')) ? eval($hook) : null; ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['Location label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[location]" size="30" maxlength="30" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[location]" size="35" maxlength="30" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_signature')) ? eval($hook) : null; ?>
@@ -1156,7 +1214,7 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['Admin note label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[admin_note]" size="30" maxlength="30" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[admin_note]" size="35" maxlength="30" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_user_details_fieldset_end')) ? eval($hook) : null; ?>
@@ -1170,7 +1228,7 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['E-mail address label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[email]" size="30" maxlength="80" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[email]" size="35" maxlength="80" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_website')) ? eval($hook) : null; ?>				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
@@ -1182,7 +1240,7 @@
 <?php ($hook = get_hook('aus_search_form_pre_jabber')) ? eval($hook) : null; ?>				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['Jabber label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[jabber]" size="30" maxlength="80" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[jabber]" size="35" maxlength="80" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_icq')) ? eval($hook) : null; ?>				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
@@ -1194,7 +1252,7 @@
 <?php ($hook = get_hook('aus_search_form_pre_msn')) ? eval($hook) : null; ?>				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['MSN Messenger label'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[msn]" size="30" maxlength="80" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[msn]" size="35" maxlength="80" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('aus_search_form_pre_aim')) ? eval($hook) : null; ?>				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
@@ -1303,7 +1361,7 @@
 					<div class="sf-box select">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_admin_users['User group label'] ?></span></label><br />
 						<span class="fld-input"><select id="fld<?php echo $forum_page['fld_count'] ?>" name="user_group">
-							<option value="all" selected="selected"><?php echo $lang_admin_users['All groups'] ?></option>
+							<option value="-1" selected="selected"><?php echo $lang_admin_users['All groups'] ?></option>
 							<option value="<?php echo FORUM_UNVERIFIED ?>"><?php echo $lang_admin_users['Unverified users'] ?></option>
 <?php
 
diff -urN punbb-1.3.4/edit.php punbb-1.3.6/edit.php
--- punbb-1.3.4/edit.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/edit.php	2011-03-07 20:13:25.892986000 +0000
@@ -91,7 +91,7 @@
 			$errors[] = $lang_post['No subject'];
 		else if (utf8_strlen($subject) > 70)
 			$errors[] = $lang_post['Too long subject'];
-		else if ($forum_config['p_subject_all_caps'] == '0' && utf8_strtoupper($subject) == $subject && !$forum_page['is_admmod'])
+		else if ($forum_config['p_subject_all_caps'] == '0' && check_is_all_caps($subject) && !$forum_page['is_admmod'])
 			$subject = utf8_ucwords(utf8_strtolower($subject));
 	}
 
@@ -100,7 +100,7 @@
 
 	if (strlen($message) > FORUM_MAX_POSTSIZE_BYTES)
 		$errors[] = sprintf($lang_post['Too long message'], forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
-	else if ($forum_config['p_message_all_caps'] == '0' && utf8_strtoupper($message) == $message && !$forum_page['is_admmod'])
+	else if ($forum_config['p_message_all_caps'] == '0' && check_is_all_caps($message) && !$forum_page['is_admmod'])
 		$message = utf8_ucwords(utf8_strtolower($message));
 
 	// Validate BBCode syntax
